// 
//  Here we place the 4 animated objects.
//
//  
  
#if (IntervalIndex = 0)                   // Static interval, two pieces on the board
  object { BlackLink rotate y*ATH translate  Link12Pos(20, 3)}    // calling macros from another file,
  object { BlackLink rotate y*(-AT2) translate Link34Pos(21, 4)}  // but this only happens once.
#else
  #if (IntervalIndex = 1)               // animated interval
    #declare NewClock123 = (clock-0.1)*1.25;               // turns .1 to .9 into 0 to 1
    #declare Path123Alpha = radians(180*NewClock123); // angle of elliptical path, 0 to pi radians
    // Path 4 is the peg, which Alpha ranges PI/2 to Pi radians, arriving at hole 1 second before the links
    #declare NewClock4 = ((clock<0.8)?(clock-0.1)*(10/7):1);
    #declare Path4Alpha   = radians(90+90*NewClock4);
    #declare Center1x = separation*8.25;       // center of ellipse. path 1 is the link3 that moves to link2.
    #declare Center1z = separation*(-8.25); 
    #declare Center2x = separation*8.5;        // Path 2 is the link1 that moves to link2.
    #declare Center2z = separation*(-9.5);
    #declare Center3x = separation*6;          // 3 is the link3 that arrives from offscreen left
    #declare Center3z = separation*(-9);
    #declare Center4x = separation*12;         // 4 is the peg arriving from offscreen right
    #declare Center4z = separation*(-8.5);
    #declare BoardVector1x = 0.25*separation;
    #declare BoardVector1z = 0.25*separation;             // vectors for the ellipse axes in the xz plane
    #declare BoardVector2x = -0.5*separation;
    #declare BoardVector2z = 0;
    #declare BoardVector3x = -2.5*separation;
    #declare BoardVector3z = 0;
    #declare BoardVector4x = 3*separation;
    #declare BoardVector4z = 0;
    #declare Height123 = separation;
    #declare Height4 = 2*separation;
    #declare RotStart1 =-AT2;
    #declare RotEnd1 = -ATH;
    #declare RotStart2 = ATH;
    #declare RotEnd2 = -ATH;
  

  
    #macro PathPos(Alpha, Centerx, Centerz, Height, BoardVectorx, BoardVectorz)
      <Centerx+BoardVectorx*cos(Alpha), Height*sin(Alpha), Centerz+BoardVectorz*cos(Alpha)>
    #end
  
     // animated paths 1 and 2 rotate during animation but nothing else.
    #macro PathRot(NewClock, RotStart, RotEnd)
      y*(RotStart+NewClock*(RotEnd-RotStart))
    #end

    #declare RotVec1 = RotStart1+NewClock123*(RotEnd1-RotStart1);
    #declare PosVec1x = Center1x+BoardVector1x*cos(Path123Alpha);
    #declare PosVec1y = Height123*sin(Path123Alpha);
    #declare PosVec1z = Center1z+BoardVector1z*cos(Path123Alpha);
    #declare RotVec2 = RotStart2+NewClock123*(RotEnd2-RotStart2);
    #declare PosVec2x = Center2x+BoardVector2x*cos(Path123Alpha);
    #declare PosVec2y = Height123*sin(Path123Alpha);
    #declare PosVec2z = Center2z+BoardVector2z*cos(Path123Alpha);
    #declare PosVec3x = Center3x+BoardVector3x*cos(Path123Alpha);
    #declare PosVec3y = Height123*sin(Path123Alpha);
    #declare PosVec3z = Center3z+BoardVector3z*cos(Path123Alpha);
    #declare PosVec4x = Center4x+BoardVector4x*cos(Path4Alpha);
    #declare PosVec4y = Height4*sin(Path4Alpha);
    #declare PosVec4z = Center4z+BoardVector4z*cos(Path4Alpha);

    #warning concat("NewClock123=",str(NewClock123,8,4)," Path123Alpha=",str(Path123Alpha,8,4),"\n")
    #warning concat("piece 1 y*",str(RotVec1,7,4)," <",str(PosVec1x,8,4),",",str(PosVec1y,8,4),",",
                   str(PosVec1z,8,4),">\n")
    #warning concat("NewClock4=",str(NewClock4,8,4)," Path4Alpha=",str(Path4Alpha,8,4),"\n")
    #warning concat("piece 2 y*",str(RotVec2,7,4)," <",str(PosVec2x,8,4),",",str(PosVec2y,8,4),",",
                   str(PosVec2z,8,4),">\n")
    #warning concat("piece 3 <",str(PosVec3x,8,4),",",str(PosVec3y,8,4),",",
                   str(PosVec3z,8,4),">\n")
    #warning concat("piece 4 <",str(PosVec4x,8,4),",",str(PosVec4y,8,4),",",
                   str(PosVec4z,8,4),">\n")
  
  
    object { BlackLink rotate PathRot(NewClock123, RotStart1, RotEnd1)
             translate  PathPos(Path123Alpha, Center1x, Center1z, Height123, BoardVector1x, BoardVector1z)
    }
    object { BlackLink rotate PathRot(NewClock123, RotStart2, RotEnd2)
             translate  PathPos(Path123Alpha, Center2x, Center2z, Height123, BoardVector2x, BoardVector2z)
    }
    object { BlackLink rotate -AT2*y  
             translate  PathPos(Path123Alpha, Center3x, Center3z, Height123, BoardVector3x, BoardVector3z)
    }
    object { BlackPeg translate  PathPos(Path4Alpha, Center4x, Center4z, Height4, BoardVector4x, BoardVector4z)
    }
  #else                        // last interval is static
    object { BlackLink rotate -ATH*y translate Link12Pos(20, 4) }    // calling macros from another file,
    object { BlackLink rotate -ATH*y translate Link12Pos(21, 3) }    // but this only happens once.
    object { BlackLink rotate -AT2*y translate Link34Pos(21, 3) }
    object { BlackPeg translate PegPos(22, 4) }
  #end
#end
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  